# Colorpicker built in Glade by Oskar Olsson. 
# It is not using buttons since they distort the colors
# by highlighting the background as well as
# produce an ugly frame.

#os.chdir("c:\dev\palette\version2")
import sys
import pygtk
import gtk
import gtk.glade

pygtk.require("2.0")

#http://python-gtk-3-tutorial.readthedocs.org/en/latest/builder.html
class ColorPalette:
  def __init__(self):
    #Working with glade projects.
    self.gladefile = "colorPalette.glade" 
    self.glade = gtk.Builder()
    self.glade.add_from_file(self.gladefile) 
    self.glade.connect_signals(self)
    self.glade.get_object("mainWindow").show_all()
    def on_MainWindow_delete_event(self, widget, event):
      gtk.main_quit()
    def select_color(arg1, arg2):
      print "you selected a color"
      print arg1
      print arg2

    #Get handles for all swatches (event boxes)
    swatch_1_1 = self.glade.get_object("swatch_1_1")#Row 1: Black, Title, Transparent
    swatch_1_6 = self.glade.get_object("swatch_1_6")
    swatch_2_1 = self.glade.get_object("swatch_2_1")#Row 2: White, Base colors
    swatch_2_2 = self.glade.get_object("swatch_2_2")
    swatch_2_3 = self.glade.get_object("swatch_2_3")
    swatch_2_4 = self.glade.get_object("swatch_2_4")
    swatch_2_5 = self.glade.get_object("swatch_2_5")
    swatch_2_6 = self.glade.get_object("swatch_2_6")
    swatch_3_1 = self.glade.get_object("swatch_3_1")#Row 3: Color swatches begins
    swatch_3_2 = self.glade.get_object("swatch_3_2")
    swatch_3_3 = self.glade.get_object("swatch_3_3")
    swatch_3_4 = self.glade.get_object("swatch_3_4")
    swatch_3_5 = self.glade.get_object("swatch_3_5")
    swatch_3_6 = self.glade.get_object("swatch_3_6")
    swatch_4_1 = self.glade.get_object("swatch_4_1")#Row4
    swatch_4_2 = self.glade.get_object("swatch_4_2")
    swatch_4_3 = self.glade.get_object("swatch_4_3")
    swatch_4_4 = self.glade.get_object("swatch_4_4")
    swatch_4_5 = self.glade.get_object("swatch_4_5")
    swatch_4_6 = self.glade.get_object("swatch_4_6")
    swatch_5_1 = self.glade.get_object("swatch_5_1")#Row5
    swatch_5_2 = self.glade.get_object("swatch_5_2")
    swatch_5_3 = self.glade.get_object("swatch_5_3")
    swatch_5_4 = self.glade.get_object("swatch_5_4")
    swatch_5_5 = self.glade.get_object("swatch_5_5")
    swatch_5_6 = self.glade.get_object("swatch_5_6")
    swatch_6_1 = self.glade.get_object("swatch_6_1")#Row6
    swatch_6_2 = self.glade.get_object("swatch_6_2")
    swatch_6_3 = self.glade.get_object("swatch_6_3")
    swatch_6_4 = self.glade.get_object("swatch_6_4")
    swatch_6_5 = self.glade.get_object("swatch_6_5")
    swatch_6_6 = self.glade.get_object("swatch_6_6")
    swatch_7_1 = self.glade.get_object("swatch_7_1")#Row7: Last swatch row
    swatch_7_2 = self.glade.get_object("swatch_7_2")
    swatch_7_3 = self.glade.get_object("swatch_7_3")
    swatch_7_4 = self.glade.get_object("swatch_7_4")
    swatch_7_5 = self.glade.get_object("swatch_7_5")
    swatch_7_6 = self.glade.get_object("swatch_7_6")
    swatch_8_1 = self.glade.get_object("swatch_8_1")#Row8: User colors
    swatch_8_2 = self.glade.get_object("swatch_8_2")
    swatch_8_3 = self.glade.get_object("swatch_8_3")
    swatch_8_4 = self.glade.get_object("swatch_8_4")
    swatch_8_5 = self.glade.get_object("swatch_8_5")
    swatch_8_6 = self.glade.get_object("swatch_8_6")

    #Get handles for all swatchImages
    swatchImage_1_1 = self.glade.get_object("swatchImage_1_1")#Row 1: Black, Title, Transparent
    swatchImage_1_6 = self.glade.get_object("swatchImage_1_6")
    swatchImage_2_1 = self.glade.get_object("swatchImage_2_1")#Row 2: White, Base colors
    swatchImage_2_2 = self.glade.get_object("swatchImage_2_2")
    swatchImage_2_3 = self.glade.get_object("swatchImage_2_3")
    swatchImage_2_4 = self.glade.get_object("swatchImage_2_4")
    swatchImage_2_5 = self.glade.get_object("swatchImage_2_5")
    swatchImage_2_6 = self.glade.get_object("swatchImage_2_6")
    swatchImage_3_1 = self.glade.get_object("swatchImage_3_1")#Row 3: Color swatches begins
    swatchImage_3_2 = self.glade.get_object("swatchImage_3_2")
    swatchImage_3_3 = self.glade.get_object("swatchImage_3_3")
    swatchImage_3_4 = self.glade.get_object("swatchImage_3_4")
    swatchImage_3_5 = self.glade.get_object("swatchImage_3_5")
    swatchImage_3_6 = self.glade.get_object("swatchImage_3_6")
    swatchImage_4_1 = self.glade.get_object("swatchImage_4_1")#Row4
    swatchImage_4_2 = self.glade.get_object("swatchImage_4_2")
    swatchImage_4_3 = self.glade.get_object("swatchImage_4_3")
    swatchImage_4_4 = self.glade.get_object("swatchImage_4_4")
    swatchImage_4_5 = self.glade.get_object("swatchImage_4_5")
    swatchImage_4_6 = self.glade.get_object("swatchImage_4_6")
    swatchImage_5_1 = self.glade.get_object("swatchImage_5_1")#Row5
    swatchImage_5_2 = self.glade.get_object("swatchImage_5_2")
    swatchImage_5_3 = self.glade.get_object("swatchImage_5_3")
    swatchImage_5_4 = self.glade.get_object("swatchImage_5_4")
    swatchImage_5_5 = self.glade.get_object("swatchImage_5_5")
    swatchImage_5_6 = self.glade.get_object("swatchImage_5_6")
    swatchImage_6_1 = self.glade.get_object("swatchImage_6_1")#Row6
    swatchImage_6_2 = self.glade.get_object("swatchImage_6_2")
    swatchImage_6_3 = self.glade.get_object("swatchImage_6_3")
    swatchImage_6_4 = self.glade.get_object("swatchImage_6_4")
    swatchImage_6_5 = self.glade.get_object("swatchImage_6_5")
    swatchImage_6_6 = self.glade.get_object("swatchImage_6_6")
    swatchImage_7_1 = self.glade.get_object("swatchImage_7_1")#Row7: Last swatch row
    swatchImage_7_2 = self.glade.get_object("swatchImage_7_2")
    swatchImage_7_3 = self.glade.get_object("swatchImage_7_3")
    swatchImage_7_4 = self.glade.get_object("swatchImage_7_4")
    swatchImage_7_5 = self.glade.get_object("swatchImage_7_5")
    swatchImage_7_6 = self.glade.get_object("swatchImage_7_6")
    swatchImage_8_1 = self.glade.get_object("swatchImage_8_1")#Row8: User colors
    swatchImage_8_2 = self.glade.get_object("swatchImage_8_2")
    swatchImage_8_3 = self.glade.get_object("swatchImage_8_3")
    swatchImage_8_4 = self.glade.get_object("swatchImage_8_4")
    swatchImage_8_5 = self.glade.get_object("swatchImage_8_5")
    swatchImage_8_6 = self.glade.get_object("swatchImage_8_6")

    #Bind click events on event boxes to
    swatch_1_1.connect("button_press_event", select_color)#
    swatch_1_6.connect("button_press_event", select_color)
    swatch_2_1.connect("button_press_event", select_color)#
    swatch_2_2.connect("button_press_event", select_color)
    swatch_2_3.connect("button_press_event", select_color)
    swatch_2_4.connect("button_press_event", select_color)
    swatch_2_5.connect("button_press_event", select_color)
    swatch_2_6.connect("button_press_event", select_color)
    swatch_3_1.connect("button_press_event", select_color)#
    swatch_3_2.connect("button_press_event", select_color)
    swatch_3_3.connect("button_press_event", select_color)
    swatch_3_4.connect("button_press_event", select_color)
    swatch_3_5.connect("button_press_event", select_color)
    swatch_3_6.connect("button_press_event", select_color)
    swatch_4_1.connect("button_press_event", select_color)#
    swatch_4_2.connect("button_press_event", select_color)
    swatch_4_3.connect("button_press_event", select_color)
    swatch_4_4.connect("button_press_event", select_color)
    swatch_4_5.connect("button_press_event", select_color)
    swatch_4_6.connect("button_press_event", select_color)
    swatch_5_1.connect("button_press_event", select_color)#
    swatch_5_2.connect("button_press_event", select_color)
    swatch_5_3.connect("button_press_event", select_color)
    swatch_5_4.connect("button_press_event", select_color)
    swatch_5_5.connect("button_press_event", select_color)
    swatch_5_6.connect("button_press_event", select_color)
    swatch_6_1.connect("button_press_event", select_color)#
    swatch_6_2.connect("button_press_event", select_color)
    swatch_6_3.connect("button_press_event", select_color)
    swatch_6_4.connect("button_press_event", select_color)
    swatch_6_5.connect("button_press_event", select_color)
    swatch_6_6.connect("button_press_event", select_color)
    swatch_7_1.connect("button_press_event", select_color)#
    swatch_7_2.connect("button_press_event", select_color)
    swatch_7_3.connect("button_press_event", select_color)
    swatch_7_4.connect("button_press_event", select_color)
    swatch_7_5.connect("button_press_event", select_color)
    swatch_7_6.connect("button_press_event", select_color)
    swatch_8_1.connect("button_press_event", select_color)#
    swatch_8_2.connect("button_press_event", select_color)
    swatch_8_3.connect("button_press_event", select_color)
    swatch_8_4.connect("button_press_event", select_color)
    swatch_8_5.connect("button_press_event", select_color)
    swatch_8_6.connect("button_press_event", select_color)

    #Define starting images in two steps (easier here then in Glade)
    #1. Assign pixbuf 
    imagePixbuf_1_1 = gtk.gdk.pixbuf_new_from_file("black.png")
    imagePixbuf_1_6 = gtk.gdk.pixbuf_new_from_file("null.png")
    imagePixbuf_2_1 = gtk.gdk.pixbuf_new_from_file("white.png")
    imagePixbuf_2_2 = gtk.gdk.pixbuf_new_from_file("base_green.png")
    imagePixbuf_2_3 = gtk.gdk.pixbuf_new_from_file("base_blue.png")
    imagePixbuf_2_4 = gtk.gdk.pixbuf_new_from_file("base_purple.png")
    imagePixbuf_2_5 = gtk.gdk.pixbuf_new_from_file("base_red.png")
    imagePixbuf_2_6 = gtk.gdk.pixbuf_new_from_file("base_yellow.png")
    imagePixbuf_3_1 = gtk.gdk.pixbuf_new_from_file("gray_1.png")
    imagePixbuf_3_2 = gtk.gdk.pixbuf_new_from_file("green_1.png")
    imagePixbuf_3_3 = gtk.gdk.pixbuf_new_from_file("blue_1.png")
    imagePixbuf_3_4 = gtk.gdk.pixbuf_new_from_file("purple_1.png")
    imagePixbuf_3_5 = gtk.gdk.pixbuf_new_from_file("red_1.png")
    imagePixbuf_3_6 = gtk.gdk.pixbuf_new_from_file("yellow_1.png")
    imagePixbuf_4_1 = gtk.gdk.pixbuf_new_from_file("gray_2.png")
    imagePixbuf_4_2 = gtk.gdk.pixbuf_new_from_file("green_2.png")
    imagePixbuf_4_3 = gtk.gdk.pixbuf_new_from_file("blue_2.png")
    imagePixbuf_4_4 = gtk.gdk.pixbuf_new_from_file("purple_2.png")
    imagePixbuf_4_5 = gtk.gdk.pixbuf_new_from_file("red_2.png")
    imagePixbuf_4_6 = gtk.gdk.pixbuf_new_from_file("yellow_2.png")
    imagePixbuf_5_1 = gtk.gdk.pixbuf_new_from_file("gray_3.png")
    imagePixbuf_5_2 = gtk.gdk.pixbuf_new_from_file("green_3.png")
    imagePixbuf_5_3 = gtk.gdk.pixbuf_new_from_file("blue_3.png")
    imagePixbuf_5_4 = gtk.gdk.pixbuf_new_from_file("purple_3.png")
    imagePixbuf_5_5 = gtk.gdk.pixbuf_new_from_file("red_3.png")
    imagePixbuf_5_6 = gtk.gdk.pixbuf_new_from_file("yellow_3.png")
    imagePixbuf_6_1 = gtk.gdk.pixbuf_new_from_file("gray_4.png")
    imagePixbuf_6_2 = gtk.gdk.pixbuf_new_from_file("green_4.png")
    imagePixbuf_6_3 = gtk.gdk.pixbuf_new_from_file("blue_4.png")
    imagePixbuf_6_4 = gtk.gdk.pixbuf_new_from_file("purple_4.png")
    imagePixbuf_6_5 = gtk.gdk.pixbuf_new_from_file("red_4.png")
    imagePixbuf_6_6 = gtk.gdk.pixbuf_new_from_file("yellow_4.png")
    imagePixbuf_7_1 = gtk.gdk.pixbuf_new_from_file("gray_5.png")
    imagePixbuf_7_2 = gtk.gdk.pixbuf_new_from_file("green_5.png")
    imagePixbuf_7_3 = gtk.gdk.pixbuf_new_from_file("blue_5.png")
    imagePixbuf_7_4 = gtk.gdk.pixbuf_new_from_file("purple_5.png")
    imagePixbuf_7_5 = gtk.gdk.pixbuf_new_from_file("red_5.png")
    imagePixbuf_7_6 = gtk.gdk.pixbuf_new_from_file("yellow_5.png")
    imagePixbuf_8_1 = gtk.gdk.pixbuf_new_from_file("user_null.png")
    imagePixbuf_8_2 = gtk.gdk.pixbuf_new_from_file("user_null.png")
    imagePixbuf_8_3 = gtk.gdk.pixbuf_new_from_file("user_null.png")
    imagePixbuf_8_4 = gtk.gdk.pixbuf_new_from_file("user_null.png")
    imagePixbuf_8_5 = gtk.gdk.pixbuf_new_from_file("user_null.png")
    imagePixbuf_8_6 = gtk.gdk.pixbuf_new_from_file("user_null.png")

    #1. Assign pixbuf 
    swatchImage_1_1.set_from_pixbuf(imagePixbuf_1_1)
    swatchImage_1_6.set_from_pixbuf(imagePixbuf_1_6)   
    swatchImage_2_1.set_from_pixbuf(imagePixbuf_2_1)#Row 2: White, Base colors
    swatchImage_2_2.set_from_pixbuf(imagePixbuf_2_2)
    swatchImage_2_3.set_from_pixbuf(imagePixbuf_2_3)
    swatchImage_2_4.set_from_pixbuf(imagePixbuf_2_4)
    swatchImage_2_5.set_from_pixbuf(imagePixbuf_2_5)
    swatchImage_2_6.set_from_pixbuf(imagePixbuf_2_6)
    swatchImage_3_1.set_from_pixbuf(imagePixbuf_3_1)#Row 3: Color swatches begins
    swatchImage_3_2.set_from_pixbuf(imagePixbuf_3_2)
    swatchImage_3_3.set_from_pixbuf(imagePixbuf_3_3)
    swatchImage_3_4.set_from_pixbuf(imagePixbuf_3_4)
    swatchImage_3_5.set_from_pixbuf(imagePixbuf_3_5)
    swatchImage_3_6.set_from_pixbuf(imagePixbuf_3_6)
    swatchImage_4_1.set_from_pixbuf(imagePixbuf_4_1)#Row4
    swatchImage_4_2.set_from_pixbuf(imagePixbuf_4_2)
    swatchImage_4_3.set_from_pixbuf(imagePixbuf_4_3)
    swatchImage_4_4.set_from_pixbuf(imagePixbuf_4_4)
    swatchImage_4_5.set_from_pixbuf(imagePixbuf_4_5)
    swatchImage_4_6.set_from_pixbuf(imagePixbuf_4_6)
    swatchImage_5_1.set_from_pixbuf(imagePixbuf_5_1)#Row5
    swatchImage_5_2.set_from_pixbuf(imagePixbuf_5_2)
    swatchImage_5_3.set_from_pixbuf(imagePixbuf_5_3)
    swatchImage_5_4.set_from_pixbuf(imagePixbuf_5_4)
    swatchImage_5_5.set_from_pixbuf(imagePixbuf_5_5)
    swatchImage_5_6.set_from_pixbuf(imagePixbuf_5_6)
    swatchImage_6_1.set_from_pixbuf(imagePixbuf_6_1)#Row6
    swatchImage_6_2.set_from_pixbuf(imagePixbuf_6_2)
    swatchImage_6_3.set_from_pixbuf(imagePixbuf_6_3)
    swatchImage_6_4.set_from_pixbuf(imagePixbuf_6_4)
    swatchImage_6_5.set_from_pixbuf(imagePixbuf_6_5)
    swatchImage_6_6.set_from_pixbuf(imagePixbuf_6_6)
    swatchImage_7_1.set_from_pixbuf(imagePixbuf_7_1)#Row7: Last swatch row
    swatchImage_7_2.set_from_pixbuf(imagePixbuf_7_2)
    swatchImage_7_3.set_from_pixbuf(imagePixbuf_7_3)
    swatchImage_7_4.set_from_pixbuf(imagePixbuf_7_4)
    swatchImage_7_5.set_from_pixbuf(imagePixbuf_7_5)
    swatchImage_7_6.set_from_pixbuf(imagePixbuf_7_6)
    swatchImage_8_1.set_from_pixbuf(imagePixbuf_8_1)#Row8: User colors
    swatchImage_8_2.set_from_pixbuf(imagePixbuf_8_2)
    swatchImage_8_3.set_from_pixbuf(imagePixbuf_8_3)
    swatchImage_8_4.set_from_pixbuf(imagePixbuf_8_4)
    swatchImage_8_5.set_from_pixbuf(imagePixbuf_8_5)
    swatchImage_8_6.set_from_pixbuf(imagePixbuf_8_6)
  
  def on_window_destroy(self, widget, data=None):
    gtk.main_quit()


    
if __name__ == "__main__":
  hwg = ColorPalette() #calls __init__
  gtk.main()
  gtk.main_quit()
print "Done"
